/*
	HSB8F3664STJ3ɐڑꂽVAEEPROM
	ɏ݂s܂B
	^[~i\tg9600bpsŐڑĂ
*/

/************************************************/
/* CN[h					*/
/************************************************/

#include "3664f.h"
#include "machine.h"


/************************************************/
/* vg^Cv錾				*/
/************************************************/

extern void reset( void );

void main( void );
void wait( int msec );

void sci_init( void );
void sci_write( unsigned char data );
unsigned char sci_read( void );
void sci_print( char *data );
void sci_print_hex_byte( unsigned char data );


void timera_init( void );


unsigned char byte_read( unsigned int addr );
void byte_write( unsigned int addr, unsigned char data );
unsigned char iic_write( unsigned char data );


void eeprom_on( void );
void eeprom_off( void );


#define size 64							/* obt@TCY */


unsigned char hh;						/*  */
unsigned char mm;						/*  */
unsigned char ss;						/* b */

/************************************************/
/* 					*/
/************************************************/

void reset( void )
#pragma asm
	mov.l		#H'FF80,ER7	;X^bN|C^
#pragma endasm
{
	set_imask_ccr( 0 );
	_INITSCT();
	main();
	sleep();
}

/*************************************************
 C
*************************************************/
void main( void )
{
	unsigned char buf[size];
	int i;

	sci_init();
	timera_init();						/* vp^C} */

	sci_print("\n\ni2c EEPROM Sample\n");

	while(1){
		sci_print("\n: ");				/* R}hvvg\ */

		buf[0] = sci_read();				/* R}hM҂*/
		sci_write( buf[0] );				/* GR[ */

		switch( buf[0] ){				/* M񔻒 */
			/*q͂ꂽꍇAǂݍݓɂȂ*/
			/*sR[h܂ŏ܂Ăf[^\*/
			case 'r':
			case 'R':
				sci_print("\nRead EEPROM\n");		/* ǂݍ */

				i = 0;					/* EEPROMoCgǂݍ */
				do{
					buf[i] = byte_read( i );
					i++;
				}while( i < size && buf[i-1] != 0x0d );

				i = 0;					/* EEPROMoCgǂݍ */
				do{
					sci_write( buf[i] );
					i++;
				}while( i < size && buf[i-1] != 0x0d );

				break;


			/*b͂ꂽꍇAeS܂*/
			case 'c':
			case 'C':
				sci_print("\nClear EEPROM\n");		/*  */
				for( i = 0; i < 0x800; i++ ){
					byte_write( i, 0xff );
				}

				break;


			/*v͂ꂽꍇAݓɂȂ*/
			/*ޕ͂^[ŏ*/
			case 'w':
			case 'W':
				sci_print("\nWrite EEPROM\n");		/*  */

				i = 0;					/* EEPROM݃f[^M */
				do{
					buf[i] = sci_read();
					sci_write( buf[i] );
					i++;
				}while( i < size && buf[i-1] != 0x0d );

				i = 0;					/* EEPROM݃f[^M */
				do{
					byte_write( i, buf[i] );
					i++;
				}while( i < size && buf[i-1] != 0x0d );

				break;

			default:
				break;
		}
	}
}

/*************************************************
 ddoqnl dnm
*************************************************/
void eeprom_on( void )
{
	*PCR8 = 0x1e;
	*PDR8 = 0x1e;				/*|[gd*/
}

/*************************************************
 ddoqnl dnee
*************************************************/
void eeprom_off( void )
{
	*PCR8 = 0x1e;
	*PDR8 = 0x00;					/*|[gd~*/
}



/*************************************************
 hhb ddoqnl oCg
*************************************************/
void byte_write( unsigned int addr, unsigned char data )
{
	unsigned char code;

	eeprom_on();

	*ICCR = 0x89;					/* 10001001 oXC^[tF[XCl[u*/
							/*	    `bjPœ]𒆒f	  */
	*ICMR = 0x00;					/* 00000000 gő		  */
	*TSCR = 0x00;					/* 00000001 				  */


	while( ( *ICCR & 0x04 ) != 0 ){			/* oXrW[tO */
	}						/* oXJ܂ő҂ */

	*ICCR = *ICCR | 0x30;				/* }X^M[hɐݒ */
	*ICCR = ( *ICCR | 0x04 ) & ~0x01;		/* X^[gRfBV */

	*PCR5 = 0x3f;					/* SCL,SDACLowɂȂĂ邩 */
	while( ( *PDR5 & 0xc0 ) != 0 ){
	}

/*	iic_write( 0xa0 );*/				/* foCXAhXAM */
	iic_write( 0xa0 + ( ( addr & 0x0700 ) >> 7 ) );	/* foCXAhXAM */
/*	iic_write( ( addr & 0xff00 ) >> 8 );*/		/* ݃AhX */
	iic_write( ( addr & 0x00ff ) );			/* ݃AhX */
	iic_write( data );				/* ݃f[^ */

	*ICCR = *ICCR & ~0x05;				/* XgbvRfBV */

	wait( 20 );					/* ݑ҂ */

	eeprom_off();

}



/*************************************************
 hhb ddoqnl oCgǂݍ
*************************************************/
unsigned char byte_read( unsigned int addr )
{
	unsigned char code;

	eeprom_on();

	*ICCR = 0x89;					/* 10001001 oXC^[tF[XCl[u*/
							/*	    `bjPœ]𒆒f	  */
	*ICMR = 0x00;					/* 00000000 gő		  */
	*TSCR = 0x00;					/* 00000001 				  */


	while( ( *ICCR & 0x04 ) != 0 ){			/* oXrW[tO */
	}						/* oXJ܂ő҂ */

	*ICCR = *ICCR | 0x30;				/* }X^M[hɐݒ */
	*ICCR = ( *ICCR | 0x04 ) & ~0x01;		/* X^[gRfBV */

	*PCR5 = 0x3f;					/* SCL,SDACLowɂȂĂ邩 */
	while( ( *PDR5 & 0xc0 ) != 0 ){
	}

/*	iic_write( 0xa0 );*/				/* foCXAhXAM */
	iic_write( 0xa0 + ( ( addr & 0x0700 ) >> 7 ) );	/* foCXAhXAM */
/*	iic_write( ( addr & 0xff00 ) >> 8 );*/		/* ݃AhX */
	iic_write( ( addr & 0x00ff ) );			/* ݃AhX */


	*ICCR = ( *ICCR | 0x04 ) & ~0x01;		/* X^[gRfBV */

	*PCR5 = 0x3f;					/* SCL,SDACLowɂȂĂ邩 */
	while( ( *PDR5 & 0xc0 ) != 0 ){
	}
	iic_write( 0xa1 );				/* foCXAhXAMA݃AhX */

	*ICCR = *ICCR & ~0x10;				/* TRS=0 */
	*ICCR = *ICCR & ~0x02;				/* IRICNA */
	*ICSR = *ICSR | 0x01;				/* ACKB=1iANmbW񑗐Mj */

	code = *ICDR;					/* _~[M */
	while( ( *ICCR & 0x02 ) == 0 ){			/* MI܂ő҂ */
	}

	*ICCR = *ICCR & ~0x02;				/* IRICNA */
	*ICCR = *ICCR | 0x10;				/* TRS=1 */

	code = *ICDR;					/* f[^M */
	while( ( *ICCR & 0x02 ) == 0 ){			/* MI܂ő҂ */
	}

	*ICCR = *ICCR & ~0x05;

	eeprom_off();

	return( code );
}



/*************************************************
 hhboXf[^o
*************************************************/
unsigned char iic_write( unsigned char data )
{

	*ICDR = data;					/* f[^ */

	*ICCR = *ICCR & ~0x02;				/* IRICNA */
	while( ( *ICCR & 0x02 ) == 0 ){			/* MI܂ő҂ */
	}

	if( ( *ICSR & 0x01 ) != 0 ){			/* ACKAĂȂ */
		sci_print("error");
		*ICCR = *ICCR & ~0x05;
		return( 1 );
	}

	return( 0 );
}


/*************************************************
 rbh
*************************************************/
void sci_init( void )
{
	unsigned long i=0;

	*SCR3 = 0x00;
	*SMR = 0x00;
/*	*BRR = 0x1f;	*/	/*9.8304MHz 9600bps*/
	*BRR = 0x2f;		/*14.7456MHz 9600bps*/

	wait( 1 );

	*SCR3 = 0x30;
	*PMR1 = 0x0e;
}



/*************************************************
 PoCgM
*************************************************/
void sci_write( unsigned char data )
{
	while( !( *SSR & 0x80 ) ){
	}						/* TDRE׸ނPɂȂ܂wait */
	*TDR = data;					/* Mް */
	while( !( *SSR & 0x04 ) ){
	}						/* TEND׸ނPɂȂ܂wait */
}



/*************************************************
 PoCgM
*************************************************/
unsigned char sci_read( void )
{
	unsigned char code;

	while( !( *SSR & 0x78 ) ){
	}
	code = *RDR;
	*SSR = *SSR & ~0x78;

	return( code );
}


/*************************************************
 VAo
*************************************************/
void sci_print( char *data )
{
	while( *data != '\0' ){				/* I[o */
		if( *data == '\n' ){			/* so */
			sci_write(0x0a);
			sci_write(0x0d);
		}else{					/* o */
			sci_write( *data );
		}

		data++;
	}

}



/*************************************************
 oCggdwo
*************************************************/
void sci_print_hex_byte( unsigned char data )
{
	const unsigned char disp_table[] = "0123456789ABCDEF";

	sci_write( disp_table[ ( data & 0xf0 ) >> 4 ] );
	sci_write( disp_table[ ( data & 0xf ) ] );
}






/*************************************************
 ^C}`
*************************************************/
void timera_init( void )
{
	*TMA = 0x18;				/* PbɃI[o[t[ */
	*IENR1 = *IENR1 | 0x40;			/* ^C}`݋ */
}

/************************************************
 ݎvp^C}`
*************************************************/

#pragma interrupt( TIMERAI )

void TIMERAI( void )
{

	*IRR1 = *IRR1 & ~0x40;
	ss++;
	if( ss >= 60 ){
		ss = 0;
		mm++;
	}
	if( mm >= 60 ){
		mm = 0;
		hh++;
	}
	if( hh >= 24 ){
		hh = 0;
	}
}






/*************************************************
 ԑ҂[v
*************************************************/
void wait( int msec )
{
	long i;
	for( i=0; i<1000 * ( long )msec; i++ ){
	}
}